#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_PopupCFG.h"
std::auto_ptr<M_PopupCFG> M_PopupCFG::msSingleton(nullptr);

int M_PopupCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_PopupCFGData* M_PopupCFG::GetData(std::string Key)
{
	auto it = mMapData.find(Key);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_PopupCFGData>& M_PopupCFG::GetMapData()
{
	return mMapData;
}

void M_PopupCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_PopupCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_PopupCFGData data;
		data.mKey = element->Attribute("Key");
		data.mScene = element->Attribute("Scene");
		data.mRewardCon = element->IntAttribute("RewardCon");
		data.mOtherDes = element->Attribute("OtherDes");
		data.mOder = element->IntAttribute("Oder");
		{
			const char* Channel = element->Attribute("Channel");
			std::vector<std::string> vecChannel;
			boost::split(vecChannel, Channel, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecChannel.size(); i++)
			{
				data.mChannel.push_back(vecChannel[i]);
			}
		}
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		CCASSERT(mMapData.find(data.mKey) == mMapData.end(), "data.mKey is exists");
		mMapData.insert(std::make_pair(data.mKey, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_PopupCFG Loaded. Load Data:%u", mMapData.size());
}

void M_PopupCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_PopupCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_PopupCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_PopupCFGData data;
		LuaCfgHelper::readString(L, "Key", data.mKey);
		LuaCfgHelper::readString(L, "Scene", data.mScene);
		LuaCfgHelper::readInt(L, "RewardCon", data.mRewardCon);
		LuaCfgHelper::readString(L, "OtherDes", data.mOtherDes);
		LuaCfgHelper::readInt(L, "Oder", data.mOder);
		LuaCfgHelper::readVectorString(L, "Channel", data.mChannel);
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		CCASSERT(mMapData.find(data.mKey) == mMapData.end(), "data.mKey is exists");
		mMapData.insert(std::make_pair(data.mKey, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_PopupCFG Loaded. Load Data:%u", mMapData.size());
}

void M_PopupCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_PopupCFG* M_PopupCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_PopupCFG());
	}
	return msSingleton.get();
}

void M_PopupCFG::Release()
{
	msSingleton.reset(nullptr);
}
